#----- 16th Feb 2022 -----#
#----- ZhangLe -----------#
#----- Modeling ----------#

from tensorflow.keras.models import Sequential
from tensorflow.keras.layers import LSTM, Dropout, Dense

# 1. lstm
def lstm_model(size = 'small', look_back = 30, foward_days, n_features, dropout=0.5):
  if size == 'small':
    NUM_NEURONS_FirstLayer = 128
  elif size == 'medium':
    NUM_NEURONS_FirstLayer = 256
  else:
    NUM_NEURONS_FirstLayer = 256
  modelLSTM = Sequential()
  modelLSTM.add(LSTM(NUM_NEURONS_FirstLayer,input_shape=(look_back, n_features), return_sequences=True))
  modelLSTM.add(Dropout(dropout))
  modelLSTM.add(Dense(foward_days))
  modelLSTM.compile(loss='mean_squared_error', optimizer='adam')
  return modelLSTM